<?php

namespace Drupal\commerce_opp\Transaction\Status;

/**
 * Abstract transaction status base class.
 */
abstract class AbstractStatus implements TransactionStatusInterface {

  /**
   * The result code.
   *
   * @var string
   */
  protected $code;

  /**
   * The status description.
   *
   * @var string
   */
  protected $description;

  /**
   * Constructs a new AbstractStatus object.
   *
   * @param string $code
   *   The result code.
   * @param string $description
   *   The status description.
   */
  public function __construct($code, $description) {
    $this->code = $code;
    $this->description = $description;
  }

  /**
   * {@inheritdoc}
   */
  public function getCode() {
    return $this->code;
  }

  /**
   * {@inheritdoc}
   */
  public function getDescription() {
    return $this->description;
  }

  /**
   * {@inheritdoc}
   */
  abstract public function getType();

}
