<?php

namespace Drupal\commerce_opp\Transaction\Status;

/**
 * Defines the transaction status interface.
 */
interface TransactionStatusInterface {

  /**
   * Gets the result code.
   *
   * @return string
   *   The result code.
   */
  public function getCode();

  /**
   * Gets the status description.
   *
   * @return string
   *   The status description.
   */
  public function getDescription();

  /**
   * Gets the type of this status.
   *
   * The result is one of the TYPE_* constants of the Constants class. As the
   * class of the given instance already implies the status type, this can be
   * seen as redundant information for convenience.
   *
   * @return string
   *   The status type (whether if the transaction was successful, failed, etc).
   */
  public function getType();

}
